#include <stdio.h>
#include <string>
#include <iostream>
#include <sstream>
#include <memory.h>

using namespace std;

#define MAXVARS (1 << 12)
#define MAXOUTPUTS (10)
#define MAXINPUTS (10)
#define MAXGATES (10 * MAXVARS)

int s[3*MAXVARS];
int v[MAXVARS];
int val[MAXOUTPUTS][1 << MAXINPUTS];
int vouts[MAXOUTPUTS];

struct gate {
	int i1, i2, o;
	int f[2][2];
	int output;

	gate() {
		memset(f, 0, sizeof(f));	
		output = -1;
	}	

	void read() {
		scanf("%d %d ", &i1, &i2);
		for (int i = 0; i < 2; i++) {
			for (int j = 0; j < 2; j++) {
				scanf("%d", &f[i][j]);
			}
		}
	}
};

gate a[MAXGATES];

void processgate(gate & g) {
	g.o = g.f[a[g.i1].o][a[g.i2].o];
}

int main() {
	freopen("sat.vars", "r", stdin);

	int t;
	while (scanf("%d", &t) == 1) {
		scanf("%d", &v[t]);
		if (v[t] == 0) {
			scanf(" : %d, %d, %d,\n", &s[3*t], &s[3*t+1], &s[3*t+2]);
		} else if (v[t] == 1) {
			scanf(" : %d, %d, %d,\n", &s[3*t], &s[3*t+1], &s[3*t+2]);
		} else if (v[t] == 2) {
			scanf(" : %d, %d,\n", &s[3*t], &s[3*t+1]);	
		} else if (v[t] == 3) {
			scanf(" : %d, %d,\n", &s[3*t], &s[3*t+1]); 
		} else if (v[t] == 4) {
			scanf(" : %d, %d,\n", &s[3*t], &s[3*t+1]); 
		}
	}

	fclose(stdin);
	
	freopen("solver.out", "r", stdin);

	int bottleneck[5];

	scanf("SAT");
	while (scanf("%d", &t) == 1) {
		if (t > 0) {
			if (v[t] == 0) {
				a[s[3*t]].f[s[3*t+1]][s[3*t+2]] = 1;		
			} else if (v[t] == 1) {
				if (s[3*t+1] == 0) {
					a[s[3*t]].i1 = s[3*t+2];
				} else {
					a[s[3*t]].i2 = s[3*t+2];
				}
			} else if (v[t] == 3) { 
				a[s[3*t]].output = s[3*t+1];
			} else if (v[t] == 4) {
				bottleneck[s[3 * t + 1]] = s[3 * t];
			}
		}
	}

	cerr << "Bottleneck:" << endl;
	for (int i = 0; i < 5; i++) {
		cerr << bottleneck[i] + 1 << " ";
	}
	cerr << endl;


	fclose(stdin);
	
	freopen("scheme.out", "w", stdout);
	
	freopen("sat.in", "r", stdin);	

	int n, m, outs;
	scanf("%d %d %d", &n, &m, &outs);
	printf("%d %d %d\n", n, m, outs);

	for (int j = 0; j < outs; j++) {
		for (int i = n; i < n + m; i++) {
			if (a[i].output == j) {
				printf("%d ", i + 1);
				vouts[j] = i;
				break;
			}
		}
	}

	printf("\n");

	for (int i = n; i < n + m; i++) {
		printf("%d: (%d, %d, ", i+1, a[i].i1+1, a[i].i2+1);
		int type = a[i].f[0][0] + a[i].f[0][1]*2 + a[i].f[1][0]*4 + a[i].f[1][1]*8;
		printf("%d)\n", type);
	}

	/**
	 * Test the correctness of circuit.
	 */
	for (int j = 0; j < outs; j++) {
		for (int i = 0; i < (1 << n); i++) {
			scanf("%d", &val[j][i]);
		}	
	}
	
	bool errors = false;

	for (int k = 0; k < outs; k++) {
		for (int i = 0; i < (1 << n); i++) {
			for (int j = 0; j < n; j++) {
				if (i & (1 << j)) {
					a[j].o = 1;
				} else {
					a[j].o = 0;
				}
			}
			for (int j = n; j < n + m; j++) {
				processgate(a[j]);
			}
			if (a[vouts[k]].o != val[k][i] && val[k][i] != 2) {
//				cerr << "ERROR on input mask " << i << endl;
//				cerr << "The value is " << a[vouts[k]].o << " should be " << val[k][i];
//				cerr << endl;
				errors = true;
			}
		}
	}

	if (!errors) {
		cerr << "OK!" << endl;
	} else {
		cerr << "BAD" << endl;
	}

	fclose(stdin);
	fclose(stdout);

	return 0;
}
